package com.example.autisme.Services;

import android.app.Notification;
import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Build;

import com.example.autisme.R;

import java.text.SimpleDateFormat;

public class TimerBroadcastReceiver extends BroadcastReceiver {

    public TimerBroadcastReceiver(){
        super();
    }

    private final String CHANNEL_ID = "autism_service_id";


    /*
     * Start notification service when get called
     */
    @Override
    public void onReceive(Context context, Intent intent) {

        SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");
        System.out.println("DISPLAYING NOTIF at : " + sdf.format(System.currentTimeMillis()));

        createNotificationChannel(context);

        Notification notification;
        NotificationManager notificationManager = (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);

        if (Build.VERSION.SDK_INT >= 26 ) {
            notification = new Notification.Builder(context, CHANNEL_ID)
                    .setContentTitle("Some Message")
                    .setContentText("You've received new messages!")
                    .setWhen(System.currentTimeMillis())
                    .setSmallIcon(R.drawable.ic_launcher_foreground)
                    .build();
        }
        else{
            notification = new Notification.Builder(context)
                    .setContentTitle("Some Message")
                    .setContentText("You've received new messages!")
                    .setWhen(System.currentTimeMillis())
                    .setSmallIcon(R.drawable.ic_launcher_background)
                    .build();
        }

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            notificationManager.notify(99, notification);
        }
        else{
            notificationManager.notify(99, notification);
        }

    }

    private void createNotificationChannel(Context context) {
        // Create the NotificationChannel, but only on API 26+ because
        // the NotificationChannel class is new and not in the support library
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            CharSequence name = "Notifications de tâches";
            String description = "";
            int importance = NotificationManager.IMPORTANCE_DEFAULT;
            NotificationChannel channel = new NotificationChannel(CHANNEL_ID, name, importance);
            channel.setDescription(description);
            NotificationManager notificationManager =
                    (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);
            notificationManager.createNotificationChannel(channel);
        }
    }
}
